#!/usr/bin/php -q
<?php
// ============================================================================
//
// Copyright (c) 2004-2005 www.telefon-sparbuch.de (Eric Berberich)
// All rights reserved.
//
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
// ----------------------------------------------------------------------------
//
// File          : etc/asterisk/lcr/tsblcrupdate.php
// Revision      : $Revision: 1.5 $
// Revision_date : $Date: 2008/08/20 20:59:34 $
//
// Author(s)     : Eric Berberich <eric@berberich.net>
//		 : Gerd Neidl <scripts@virtualpinguin.de>
//
// ============================================================================


// argv[1]: config file to read
// argv[2]: routing file to write

if ($argc != 3) {
    exit;
}

// path to lcr
$lastmoddir = "/etc/asterisk/lcr";
$cron_mail_if_no_update = false; 


$configfile = $argv[1];
$routingfile = $argv[2];

$update = false;

// TODO if not tsblcr.lastmod

if ($configfile && is_readable($configfile)) {
    // read time of last local change
    $handle = fopen("$lastmoddir/tsblcr.lastmod", "r");
    $lcrfiletime = strtotime(fgets($handle));
    fclose($handle);
    
    // check if cfg file is newer than last download
    $cfgfiletime = filemtime($configfile);
    if ($cfgfiletime > $lcrfiletime) {
        echo "New config file!\n";
        $update = true;
    }
    
    // read time of last server change
    $handle = fopen("http://www.telefonsparbuch.de/nocache/info.lcr.last_modified.txt", "r");
    $filetime = strtotime(fgets($handle));
    fclose($handle);
    
    if (!$update) {
        if ($routingfile && is_file($routingfile)) {
            // check against local change
            if ($filetime > $lcrfiletime) {
                echo "Newer file on server!\n";
                $update = true;
            } 
        } else {
            $update = true;
        }
    }
    
    if ($update) {
        echo "Waiting ... ";
        sleep(rand(0,30));
        echo "done.\n";

        echo "Download now ... ";
        $wgetcmd = "wget -N -S http://www.telefonsparbuch.de/tmpl/calc/telephone/lcr/Asterisk/download/index.htm --post-data 'VERSION=1&TAKE_FILE=" . urlencode(file_get_contents($configfile)) ."' 2> /dev/null";
        system($wgetcmd);
        echo "done.\n";

        echo "Update routing file ... ";
        system("mv index.htm $routingfile");
        echo "done.\n";

        echo "Update lastmod file ... ";
        $handle = fopen("$lastmoddir/tsblcr.lastmod","w");
        fputs($handle, gmdate("r", $filetime));
        fclose($handle);
        echo "done.\n";

    } elseif ($cron_mail_if_no_update) {
        echo "Config and routing files still valid! No download needed!\n";
    }

} else {
    echo "No config file specified!\n";
}

?>
